﻿'by julionib

'keep the violence in games :)
'be cool

Imports System ' basic imports
Imports GTA ' basic imports
Imports System.Windows.Forms ' needed to have access to "keys" enumeration, for example
Imports System.Drawing ' needed to handle colors referencing the color name, ex: myCar.color = System.Drawing.Color.Black
Imports System.Collections.Generic
Imports System.IO

Public Class AC130
    Inherits Script

    Private bInAC130 As Boolean
    Private NightVisionMode As Int16 = 0
    Private bResetTimeCycle As Boolean = False
    Private Rocket As gta.object
    Private plane As gta.object
    Private planeHeading As Double = 0
    Private timeScript As Int16 = 0
    Private timeWaitResetDeathArrest As Double = 0
    Private RocketExpTimeout As int16 = 0
    Private RocketDelay As int16 = 150
    Private vecOriginalPos As vector3
    Private rocketEffect As int32 = 0
    Private rocketRotation As vector3
    Private camDelay As int16 = 0
    'Private lightList As New list(Of lights)
    'Private lightTmp As lights = Nothing
    Private bCancelLights As Boolean = False
    Private noiseEffectCounter As int16 = 0
    Private timeShoot20mm As int16 = 0
    Private timeShoot40mm As int16 = 0
    Private bDraw20mmTrace As Boolean = False
    Private dot40mmList As New list(Of dot40mm)
    Private camMode As int16 = 0
    Private currWeapon As int16 = 0
    Private camDir, camDirOrig As vector3
    Private dot40mmBullet As int16 = 0
    Private dot20mmTimeScarePeds As Double = 0
    Private bNoiseFX = False
    Private bCrosshair As Boolean = True
    Private playerPosAux As vector3
    Private trainList As New list(Of trains)
    Private trainItem As trains
    Private timeNVFindObj, timeNVGlowObj, timeNVFindObjCount, timeNVGlowObjCount As Double
    Private shakeCam As Double = 0
    Private shakeCamAmount As Double = 0
    Private camDEDir As vector3
    Private planeSpeedMultiplier As Double = 1
    Private camHeight, camHeightAux As Double
    Private bErroDraw As Boolean = False
    Private maxDistFindTargets As Double
    Private loadDelay As Int16 = 100
    Private bDisableTextures As Boolean = False
    Private camFOV As Double = 50
    Private camAimHUDObj As GTA.Object = Nothing

    Private sVersion As String = "1.1"

    'cameras section
    Private camAC130, camRocket, camDEAim As camera

    'hotkeys section
    Private hkActivate1, hkActivate2, hkShoot, hkChangeGun, hkNightvision, hkCameraMode, hkSwTo105mm, hkSwTo40mm, hkSwTo20mm, _
        hkSpeedUp, hkSpeedDown As keys

    'sprites section
    Private texCr20, texCr40, texCr105, tex20, tex40, tex105, text20mmTrace, textDEAim As Texture

    '"deadEye" section
    Private bDeadEye As Boolean = False
    Private findTargetTime As Double
    Private DETarget As targetFound
    Private DEShoots As int16 = 0
    Private camDEAimFOV As Int16 = 50
    Private DEPossibleTargetVeh As Vehicle()
    Private DEPossibleTargetPed As Ped()

    Private myHeight, myWidth, height_coef, width_coef As Double
    Private bUseCUstomResolution As Boolean = False

    'night vision - peds
    Private Class NVPed
        Public p As Ped = Nothing
        Private l As Light = New Light(Color.Green, 1, 1000)
        Private l2 As Light = New Light(Color.Green, 1, 1000)
        Public removeTime As Double = -666

        Public Sub reset()
            p = Nothing
            l.Intensity = 1000
            l2.Intensity = 1000
            removeTime = -666
        End Sub

        Public Sub update(cam As Camera)
            Try
                If Not p Is Nothing Then
                    If Not l Is Nothing Then
                        If removeTime > 0 Then l.Intensity = l.Intensity * (removeTime / 7000)

                        l.Position = p.Position - cam.Direction * 0.5 + Vector3.WorldUp * 0.3
                        l.Enabled = True
                    End If

                    If Not l2 Is Nothing AndAlso p.CurrentVehicle Is Nothing Then
                        If removeTime > 0 Then l2.Intensity = l2.Intensity * (removeTime / 7000)

                        l2.Position = p.Position - cam.Direction * 0.5 + Vector3.WorldDown * 0.5
                        l2.Enabled = True
                    End If

                    If (p.Health <= 0) AndAlso (removeTime = -666) Then removeTime = 7000

                    If removeTime > 0 Then
                        removeTime -= intervalFix()

                        If removeTime <= 0 Then
                            p = Nothing
                            If Not l Is Nothing Then l.Enabled = False
                            If Not l2 Is Nothing Then l2.Enabled = False
                        End If
                    End If
                End If
            Catch
                p = Nothing
                If Not l Is Nothing Then l.Enabled = False
                If Not l2 Is Nothing Then l2.Enabled = False
            End Try
        End Sub

        Public Sub hide()
            p = Nothing
            If Not l Is Nothing Then l.Enabled = False
            If Not l2 Is Nothing Then l2.Enabled = False
        End Sub

        Public Sub delete()
            p = Nothing

            If Not l Is Nothing Then
                l.Disable()
                l = Nothing
            End If

            If Not l2 Is Nothing Then
                l2.Disable()
                l2 = Nothing
            End If
        End Sub
    End Class

    'night vision - vehicles
    Private Class NVVeh
        Public v As Vehicle = Nothing
        Private tmpLight As Light
        Private lights As New List(Of Light)
        Private vehZ, vehX, vehY, space, half As Double
        Public removeTime As Double = -666

        Public Sub New()
            vehZ = 0
            vehX = 0
            vehY = 0
        End Sub

        Public Sub update(cam As Camera)
            Try
                If Not v Is Nothing AndAlso v.isOnScreen Then
                    If vehZ = 0 Then
                        Dim tmpVehDim As Vector3 = v.Model.GetDimensions
                        vehZ = tmpVehDim.Z
                        vehX = tmpVehDim.X
                        vehY = tmpVehDim.Y

                        If v.Model.isHelicopter Then vehX /= 4

                        For c As Int16 = 0 To Math.Round(vehX)
                            tmpLight = New Light(Color.Green, vehZ * 1.7, 1000)
                            lights.Add(tmpLight)

                            If lights.Count > 5 Then Exit For
                        Next

                        If lights.Count < 3 Then
                            tmpLight = New Light(Color.Green, vehZ * 1.7, 1000)
                            lights.Add(tmpLight)
                        End If

                        space = (vehY + 2) / lights.Count * 0.9
                        half = lights.Count / 2

                        If v.Model.isHelicopter Then
                            half = 5
                            space = 0.7
                        End If
                    End If

                    For c As Int16 = 0 To lights.Count - 1
                        If Not lights(c) Is Nothing Then
                            If removeTime > 0 Then lights(c).Intensity = lights(c).Intensity * (removeTime / 7000)

                            lights(c).Position = v.GetOffsetPosition(Vector3.RelativeBack * (half - c) * space) + Vector3.WorldUp * vehZ
                            lights(c).Enabled = True
                        End If
                    Next

                    If (v.Health <= 0) AndAlso (removeTime = -666) Then removeTime = 7000

                    If removeTime > 0 Then
                        removeTime -= intervalFix()

                        If removeTime <= 0 Then
                            v = Nothing
                            For Each l In lights
                                If Not l Is Nothing Then
                                    l.Enabled = False
                                End If
                            Next
                        End If
                    End If
                End If
            Catch
                v = Nothing
                For Each l As Light In lights
                    If Not l Is Nothing Then
                        l.Enabled = False
                    End If
                Next
            End Try
        End Sub

        Public Sub hide()
            v = Nothing
            For Each l In lights
                If Not l Is Nothing Then
                    l.Enabled = False
                End If
            Next
        End Sub

        Public Sub delete()
            v = Nothing

            For Each l In lights
                If Not l Is Nothing Then
                    l.Disable()
                     l = Nothing
                End If
            Next
        End Sub
    End Class

    Private NVFoundPed As Ped()
    Private NVPedList As New List(Of NVPed)
    Private NVFoundVeh As Vehicle()
    Private NVVehList As New List(Of NVVeh)
    Private timeWaitRefreshNV As Double = 0

    Public Sub New()
        Me.interval = 10
    End Sub

    Private Function createObject(ByRef o As GTA.Object, sModel As String, pos As Vector3, timewait As Int16) As Boolean
        While Not Exists(o)
            o = World.CreateObject(sModel, pos)

            Wait(timewait)
        End While
    End Function

    Private Sub loadAux()
        Game.Console.Print("AC130 Script Mod by JulioNIB v" & sVersion)
        Game.Console.Print("Sprites, sounds and idea by TheVideoVolcano")

        camAC130 = New Camera
        camRocket = New Camera
        camDEAim = New Camera

        If Exists(camAC130) Then camAC130.FOV = Game.CurrentCamera.FOV
        If Exists(camRocket) Then camRocket.FOV = Game.CurrentCamera.FOV
        If Exists(camDEAim) Then camDEAim.FOV = Game.CurrentCamera.FOV

        timeNVFindObjCount = 0
        timeNVGlowObjCount = 0

        bInAC130 = False
        NightVisionMode = 0

        findTargetTime = 0

        DETarget = New targetFound

        camHeight = 0
        camHeightAux = 0

        'If Settings.GetValueKey("bNoiseFX", "General", -1) = -1 Then Settings.SetValue("bNoiseFX", "General", 1)
        If Settings.GetValueKey("bCrosshair", "General", -1) = -1 Then Settings.SetValue("bCrosshair", "General", 1)
        If Settings.GetValueKey("maxDistFindTargets", "General", -1) = -1 Then Settings.SetValue("maxDistFindTargets", "General", 200)
        'If Settings.GetValueKey("bDisableTextures", "General", -1) = -1 Then
        '    If Game.CurrentEpisode = GameEpisode.GTAIV Then
        '        Settings.SetValue("bDisableTextures", "General", 0)
        '    Else
        '        Settings.SetValue("bDisableTextures", "General", 1)
        '    End If
        'End If
        If Settings.GetValueKey("timeNVFindObj", "NightVision", -1) = -1 Then Settings.SetValue("timeNVFindObj", "NightVision", 500)
        If Settings.GetValueKey("timeNVGlowObj", "NightVision", -1) = -1 Then Settings.SetValue("timeNVGlowObj", "NightVision", 20)

        If Settings.GetValueKey("hkActivate1", "HotKeys", -1) = -1 Then Settings.SetValue("hkActivate1", "HotKeys", Keys.F7)
        If Settings.GetValueKey("hkActivate2", "HotKeys", -1) = -1 Then Settings.SetValue("hkActivate2", "HotKeys", Keys.F8)
        If Settings.GetValueKey("hkShoot", "HotKeys", -1) = -1 Then Settings.SetValue("hkShoot", "HotKeys", Keys.LButton)
        If Settings.GetValueKey("hkChangeGun", "HotKeys", -1) = -1 Then Settings.SetValue("hkChangeGun", "HotKeys", Keys.RButton)
        If Settings.GetValueKey("hkNightvision", "HotKeys", -1) = -1 Then Settings.SetValue("hkNightvision", "HotKeys", Keys.N)
        If Settings.GetValueKey("hkCameraMode", "HotKeys", -1) = -1 Then Settings.SetValue("hkCameraMode", "HotKeys", Keys.C)
        If Settings.GetValueKey("hkSwTo105mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo105mm", "HotKeys", Keys.D1)
        If Settings.GetValueKey("hkSwTo40mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo40mm", "HotKeys", Keys.D2)
        If Settings.GetValueKey("hkSwTo20mm", "HotKeys", -1) = -1 Then Settings.SetValue("hkSwTo20mm", "HotKeys", Keys.D3)
        If Settings.GetValueKey("hkSpeedUp", "HotKeys", -1) = -1 Then Settings.SetValue("hkSpeedUp", "HotKeys", Keys.W)
        If Settings.GetValueKey("hkSpeedDown", "HotKeys", -1) = -1 Then Settings.SetValue("hkSpeedDown", "HotKeys", Keys.S)

        If Settings.GetValueString("bUseCUstomResolution", "general", "") = "" Then Settings.SetValue("bUseCUstomResolution", "general", "0")
        If Settings.GetValueString("custom_width", "general", "") = "" Then Settings.SetValue("custom_width", "general", Game.Resolution.Width)
        If Settings.GetValueString("custom_height", "general", "") = "" Then Settings.SetValue("custom_height", "general", Game.Resolution.Height)

        myHeight = Int16.Parse(Settings.GetValueString("custom_width", "general", Game.Resolution.Height.ToString))
        myWidth = Int16.Parse(Settings.GetValueString("custom_height", "general", Game.Resolution.Width.ToString))

        bUseCUstomResolution = Settings.GetValueString("bUseCUstomResolution", "general", "") = "1"

        If Not bUseCUstomResolution Then
            myHeight = Game.Resolution.Height
            myWidth = Game.Resolution.Width
        End If

        width_coef = myWidth / 1664
        height_coef = myHeight / 1012

        Settings.Save()

        bNoiseFX = Settings.GetValueKey("bNoiseFX", "General", 1) = 1
        'bCrosshair = Settings.GetValueKey("bCrosshair", "General", 1) = 1
        maxDistFindTargets = Settings.GetValueKey("maxDistFindTargets", "General", 200)
        'bDisableTextures = Settings.GetValueKey("bDisableTextures", "General", 0) = 1

        timeNVFindObj = Settings.GetValueKey("timeNVFindObj", "NightVision", 500)
        timeNVGlowObj = Settings.GetValueKey("timeNVGlowObj", "NightVision", 20)

        hkActivate1 = Settings.GetValueKey("hkActivate1", "HotKeys", Keys.F7)
        hkActivate2 = Settings.GetValueKey("hkActivate2", "HotKeys", Keys.F8)
        hkShoot = Settings.GetValueKey("hkShoot", "HotKeys", Keys.LButton)
        hkChangeGun = Settings.GetValueKey("hkChangeGun", "HotKeys", Keys.RButton)
        hkNightvision = Settings.GetValueKey("hkNightvision", "HotKeys", Keys.N)
        hkCameraMode = Settings.GetValueKey("hkCameraMode", "HotKeys", Keys.C)
        hkSwTo105mm = Settings.GetValueKey("hkSwTo105mm", "HotKeys", Keys.D1)
        hkSwTo40mm = Settings.GetValueKey("hkSwTo40mm", "HotKeys", Keys.D2)
        hkSwTo20mm = Settings.GetValueKey("hkSwTo20mm", "HotKeys", Keys.D3)
        hkSpeedUp = Settings.GetValueKey("hkSpeedUp", "HotKeys", Keys.W)
        hkSpeedDown = Settings.GetValueKey("hkSpeedDown", "HotKeys", Keys.S)

        Try
            texCr20 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\cr20mm.png"))
            texCr40 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\cr40mm.png"))
            texCr105 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\cr105mm.png"))
            tex20 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\20.png"))
            tex40 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\40.png"))
            tex105 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\105.png"))
            text20mmTrace = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\20mmTrace.png"))
            textDEAim = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\DeadEyeAim.png"))
            'textN1 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\N1.png"))
            'textN2 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\N2.png"))
            'textN3 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\N3.png"))
            'textN4 = New Texture(File.ReadAllBytes(".\Scripts\AC130Files\N4.png"))
        Catch
        End Try

        Try
            'Rocket = World.CreateObject("cj_rpg_rocket", vecOriginalPos + Vector3.WorldUp * 300)
            'plane = World.CreateObject("cj_plane_1", vecOriginalPos + Vector3.WorldUp * 305)

            createObject(Rocket, "cj_rpg_rocket", Vector3.Zero, 10)
            createObject(plane, "cj_plane_1", Vector3.Zero, 10)
            createObject(camAimHUDObj, "cj_dart_1", Vector3.Zero, 10)

            If Exists(Rocket) Then
                Rocket.Visible = False
                Native.Function.Call("SET_OBJECT_COLLISION", Rocket, False)
            End If
            If Exists(plane) Then
                plane.Visible = False
                Native.Function.Call("SET_OBJECT_COLLISION", plane, False)
            End If

            For Each bul As dot40mm In dot40mmList
                If Exists(bul.bullet) Then bul.bullet.Delete()
            Next

            dot40mmList.Clear()

            Dim tmp40mm As dot40mm

            For c As Int16 = 1 To 10
                tmp40mm = New dot40mm(vecOriginalPos + Vector3.WorldUp * 30, plane)

                Wait(10)

                If Exists(tmp40mm.bullet) Then
                    Native.Function.Call("SET_OBJECT_COLLISION", tmp40mm.bullet, False)
                    dot40mmList.Add(tmp40mm)
                End If
            Next
        Catch
        End Try
    End Sub

    Private Sub NVTick()
        If timeWaitRefreshNV <= 0 Then
            timeWaitRefreshNV = 300

            For Each n As NVPed In NVPedList
                If Not Exists(n.p) OrElse ((n.removeTime <> -666) AndAlso (n.removeTime <= 0)) Then
                    n.delete()
                End If
            Next

            For Each n As NVVeh In NVVehList
                If Not Exists(n.v) OrElse ((n.removeTime <> -666) AndAlso (n.removeTime <= 0)) Then
                    n.delete()
                End If
            Next

            Dim tmpNVPed As NVPed
            Dim bEmptyFound As Boolean = False
            Dim bFound As Boolean = False

            NVFoundPed = World.GetAllPeds

            For Each p As Ped In NVFoundPed
                If Exists(p) AndAlso (p <> Player.Character) AndAlso (p.Health > 0) Then
                    Try
                        bFound = False
                        bEmptyFound = False

                        For Each n As NVPed In NVPedList
                            If n.p = p Then
                                bFound = True
                                Exit For
                            End If
                        Next

                        If Not bFound Then
                            For Each n As NVPed In NVPedList
                                If Not Exists(n.p) Then
                                    tmpNVPed = n
                                    bEmptyFound = True
                                    Exit For
                                End If
                            Next

                            If Not bEmptyFound Then
                                tmpNVPed = New NVPed
                                tmpNVPed.p = p
                                NVPedList.Add(tmpNVPed)
                            Else
                                tmpNVPed.reset()
                                tmpNVPed.removeTime = -666
                                tmpNVPed.p = p
                                tmpNVPed.update(Game.CurrentCamera)
                            End If
                        End If
                    Catch
                    End Try
                End If
            Next

            For c As Int16 = NVPedList.Count - 1 To 0 Step -1
                If Not Exists(NVPedList(c).p) Then
                    NVPedList(c).delete()
                    NVPedList.RemoveAt(c)
                End If
            Next

            Dim tmpNVVeh As NVVeh

            NVFoundVeh = World.GetAllVehicles

            For Each v As Vehicle In NVFoundVeh
                If Exists(v) AndAlso (v.Health > 0) AndAlso (v <> Player.Character.CurrentVehicle) Then
                    Try
                        bFound = False

                        For Each n As NVVeh In NVVehList
                            If n.v = v Then
                                bFound = True
                                Exit For
                            End If
                        Next

                        If Not bFound Then
                            bEmptyFound = False

                            For Each n As NVVeh In NVVehList
                                If Not Exists(n.v) Then
                                    tmpNVVeh = n
                                    bEmptyFound = True
                                    Exit For
                                End If
                            Next

                            If Not bEmptyFound Then
                                tmpNVVeh = New NVVeh
                                tmpNVVeh.v = v
                                NVVehList.Add(tmpNVVeh)
                            Else
                                NVVehList(NVVehList.IndexOf(tmpNVVeh)).v = v
                            End If
                        End If
                    Catch
                    End Try
                End If
            Next

            For c As Int16 = NVVehList.Count - 1 To 0 Step -1
                If Not Exists(NVVehList(c).v) Then
                    NVVehList(c).delete()
                    NVVehList.RemoveAt(c)
                End If
            Next
        Else
            timeWaitRefreshNV -= intervalFix()
        End If

        For Each n As NVPed In NVPedList
            n.update(Game.CurrentCamera)
        Next

        For Each n As NVVeh In NVVehList
            n.update(Game.CurrentCamera)
        Next
    End Sub

    Private Sub ClearNVLists()
        For c As Int16 = NVPedList.Count - 1 To 0 Step -1
            NVPedList(c).delete()
            NVPedList.RemoveAt(c)
        Next

        For c As Int16 = NVVehList.Count - 1 To 0 Step -1
            NVVehList(c).delete()
            NVVehList.RemoveAt(c)
        Next
    End Sub

    Private Class dot40mm
        Public bullet As GTA.Object
        Public launched As Boolean = False
        Public dir As Vector3
        Public timeOut
        Public ptfx As Int32 = 0

        Public Sub New(pos As Vector3, attachTo As GTA.Object)
            bullet = World.CreateObject("w_grenade", pos)

            Try
                bullet.Visible = False

                Native.Function.Call("ATTACH_OBJECT_TO_OBJECT", bullet, attachTo, False, 0, 0, 0, 0, 0, 0)
            Catch
            End Try

            timeOut = 0
        End Sub
    End Class

    Private Class trains
        Public pos, rot, vel As Vector3
        Public m As Model
        Public train As GTA.Object
        Public bCreate As Boolean = True
        Public speed As Double

        Public Sub New(v As GTA.Vehicle)
            pos = v.Position
            rot = v.Rotation
            speed = v.Speed
            m = v.Model
            train = Nothing
        End Sub
    End Class

    Private Class targetFound
        Public p As Ped = Nothing
        Public v As Vehicle = Nothing
        Public vec As Vector3 = Vector3.Zero
        Public bPed As Boolean = False
        Public bVeh As Boolean = False
        Public valid As Boolean = False

        Public Sub reset()
            bPed = False
            bVeh = False
            p = Nothing
            v = Nothing
            valid = False
        End Sub

        Public Sub New()
        End Sub
    End Class

    Private Sub DETargetUpdateVec()
        If DETarget.bPed Then
            If Exists(DETarget.p) Then
                DETarget.vec = DETarget.p.Position
            Else
                DETarget.p = Nothing
                DETarget.bPed = False
                DETarget.valid = False
            End If
        ElseIf DETarget.bVeh Then
            If Exists(DETarget.v) Then
                DETarget.vec = DETarget.v.Position
            Else
                DETarget.v = Nothing
                DETarget.bVeh = False
                DETarget.valid = False
            End If
        End If
    End Sub

    Private Sub msg(sMsg As String, time As Int32)
        Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", sMsg, time, 1)
    End Sub

    Private Sub keyDown(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown
        fakeKeyDown(e.Key)
    End Sub
    Private Sub keyUp(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyUp
    End Sub

    Private Sub fakeKeyDown(key As Keys)
        If ((key = hkActivate1) OrElse (key = hkActivate2)) AndAlso (Not Exists(Rocket) OrElse (Exists(Rocket) AndAlso Not Rocket.Metadata.launched)) Then
            toggleONOff(key)

            Exit Sub
        End If

        If bInAC130 Then
            If Not bDeadEye Then
                If key = (hkSpeedUp) Then planeSpeedMultiplier += 0.1
                If key = (hkSpeedDown) Then planeSpeedMultiplier -= 0.1

                If planeSpeedMultiplier > 2 Then
                    planeSpeedMultiplier = 2
                ElseIf planeSpeedMultiplier < 0.5 Then
                    planeSpeedMultiplier = 0.5
                End If

                If key = hkShoot Then
                    Player.Character.WantedByPolice = True
                    Native.Function.Call("ALTER_WANTED_LEVEL_NO_DROP", Player, 2)
                    Native.Function.Call("APPLY_WANTED_LEVEL_CHANGE_NOW", Player, 2)
                End If

                If (key = hkShoot) AndAlso (currWeapon = 0) AndAlso Not Rocket.Metadata.launched Then
                    fire105mm(True)
                End If

                If (key = hkNightvision) AndAlso Not Rocket.Metadata.launched Then
                    Native.Function.Call("CLEAR_TIMECYCLE_MODIFIER")

                    NightVisionMode += 1

                    If NightVisionMode > 2 Then NightVisionMode = 0

                    If NightVisionMode = 0 Then
                        ClearNVLists()
                    ElseIf NightVisionMode = 2 Then
                        If Game.CurrentEpisode = GameEpisode.GTAIV Then
                            NightVisionMode = 0
                        Else
                            Native.Function.Call("SET_TIMECYCLE_MODIFIER", "death")
                            bResetTimeCycle = True
                        End If
                    End If
                End If

                If (key = hkCameraMode) AndAlso Not Rocket.Metadata.launched Then
                    camMode += 1

                    If camMode > 2 Then camMode = 0

                    If camMode = 0 Then
                        msg("105mm Normal camera", 3000)
                    ElseIf camMode = 1 Then
                        msg("105mm Camera on board", 3000)
                    Else
                        msg("105mm Ground camera", 3000)
                    End If
                End If

                If (key = hkChangeGun) AndAlso Not camRocket.isActive Then
                    currWeapon += 1

                    If currWeapon > 2 Then currWeapon = 0
                End If

                If key = hkSwTo105mm Then
                    currWeapon = 0
                ElseIf key = hkSwTo40mm Then
                    currWeapon = 1
                ElseIf key = hkSwTo20mm Then
                    currWeapon = 2
                End If
            Else
                If (key = Keys.RButton) Then
                    'If Not Player.Character.Weapons.inSlot(WeaponSlot.Handgun).isPresent Then
                    '    Native.Function.Call("GIVE_WEAPON_TO_CHAR", Player.Character, 4, 7, 1)
                    'End If

                    'If (Player.Character.Weapons.Current <> WeaponSlot.Handgun) Then Player.Character.Weapons.inSlot(WeaponSlot.Handgun).Select()
                    Player.Character.Task.ClearAll()
                    Player.Character.Weapons.inSlot(WeaponSlot.Unarmed).Select()

                    camDEAim.Deactivate()

                    camDEDir = Game.CurrentCamera.Direction

                    camDEAimFOV = 50

                    If Not camDEAim.isActive Then camDEAim.Activate()
                End If

                If (key = hkSwTo105mm) AndAlso Not Rocket.Metadata.launched AndAlso DETarget.valid Then
                    currWeapon = 0

                    If DETarget.valid Then
                        resetPlanePos()

                        fire105mm(True)
                    End If
                End If

                If (key = hkSwTo40mm) AndAlso DETarget.valid Then
                    currWeapon = 1

                    resetPlanePos()

                    DEShoots = 10
                End If

                If (key = hkSwTo20mm) AndAlso DETarget.valid Then
                    currWeapon = 2

                    resetPlanePos()

                    DEShoots = 20
                End If
            End If
        End If
    End Sub

    Private Sub toggleONOff(key As Keys)
        If timeWaitResetDeathArrest > 0 Then
            bInAC130 = False

            msg("Reseting AC130 script, wait " & Math.Round(timeWaitResetDeathArrest / 1000).ToString & " s...", 2000)

            Exit Sub
        End If

        If Not bInAC130 Then
            msg("Calling AC130...", 2000)

            bDeadEye = (key = hkActivate2)

            currWeapon = 0
            camMode = 0
            NightVisionMode = 0

            vecOriginalPos = Player.Character.Position
            playerPosAux = vecOriginalPos

            Try
                'If Not exists(Rocket) Then Rocket = world.createobject("cj_rpg_rocket", vecOriginalPos + vector3.worldup * 300)
                'If Not exists(plane) Then plane = world.createobject("cj_plane_1", vecOriginalPos + vector3.worldup * 305)
                If Not Exists(Rocket) Then createObject(Rocket, "cj_rpg_rocket", Vector3.Zero, 10)
                If Not Exists(plane) Then createObject(plane, "cj_plane_1", Vector3.Zero, 10)

                Native.Function.Call("SET_OBJECT_COLLISION", Rocket, True)
                Native.Function.Call("SET_OBJECT_COLLISION", plane, True)
                'Rocket.visible = true
                plane.Visible = True

                For Each bul As dot40mm In dot40mmList
                    If Exists(bul.bullet) Then bul.bullet.Delete()
                Next

                dot40mmList.Clear()

                Dim tmp40mm As dot40mm

                For c As Int16 = 1 To 10
                    tmp40mm = New dot40mm(vecOriginalPos + Vector3.WorldUp * 30, plane)

                    Wait(10)

                    dot40mmList.Add(tmp40mm)
                Next
            Catch
                msg("Error creating objects, try again...", 2000)

                If Exists(plane) Then plane.Delete()
                If Exists(Rocket) Then Rocket.Delete()

                Exit Sub
            End Try

            Native.Function.Call("ATTACH_OBJECT_TO_OBJECT", Rocket, plane, False, 0, 0, 0, 0, 0, 0)

            planeHeading = 15
            plane.Heading = planeHeading

            If Not bDeadEye Then
                plane.Position = vecOriginalPos + Player.Character.Direction * -200 + Vector3.WorldUp * 250
                plane.Visible = False
            Else
                plane.Position = vecOriginalPos + Player.Character.Direction * 20 + Vector3.WorldUp * 250
                plane.Visible = True
            End If

            camAC130.Position = plane.Position
            camDir = plane.Direction
            camDir.Z = -2
            camDirOrig = camDir
            camAC130.Direction = rotateVec(camDir, 60)

            Rocket.Visible = False

            If Not bDeadEye Then
                Game.FadeScreenOut(1000, True)

                Player.Character.Visible = False
                'native.function.call("ATTACH_PED_TO_OBJECT", player.character, plane, false, 0, 0, 0, 0, 0, false, false)
                'native.function.call("ATTACH_PED_TO_OBJECT", player.character, rocket, false, 0, 0, 0, 0, 0, false, false)
                'native.function.call("ATTACH_PED_TO_OBJECT", player.character, plane, false, 0, 0, -230.0, 0, 0, false, false)

                Player.Character.MakeProofTo(True, True, True, True, True)
                Native.Function.Call("SET_CHAR_COLLISION", Player.Character, False)

                'player.character.attachblip
                'plane.attachblip

                Game.FadeScreenIn(500)

                bDraw20mmTrace = True
            End If

            If Not bDeadEye Then Player.CanControlCharacter = False

            bInAC130 = True

            msg("Our AC130 is on air...", 2000)
        Else
            Player.CanControlCharacter = True

            bInAC130 = False

            If Not bDeadEye Then
                Game.FadeScreenOut(1000, True)

                Player.Character.Detach()
                Player.Character.FreezePosition = True
                Player.Character.Position = vecOriginalPos
                Native.Function.Call("SET_CHAR_COLLISION", Player.Character, True)
                Player.Character.FreezePosition = False
                Player.Character.Visible = True
                Player.Character.MakeProofTo(False, False, False, False, False)
                Wait(500)
            End If

            plane.Visible = False
            Rocket.Visible = False

            camAC130.Deactivate()
            camRocket.Deactivate()

            NightVisionMode = 0

            ClearNVLists()

            If Not bDeadEye Then Game.FadeScreenIn(500)

            msg("AC130 did his job...", 2000)
        End If
    End Sub

    Private Sub updatePlaneMov()
        plane.Position = plane.Position - plane.Direction * 1.5

        plane.Heading = planeHeading

        planeHeading += 0.4

        If planeHeading > 360 Then planeHeading = 0

        camAC130.Position = plane.Position
    End Sub

    Private Sub resetPlanePos()
        plane.Position = Player.Character.Position - Game.CurrentCamera.Direction * 5 + Vector3.WorldUp * 250
        camAC130.Position = plane.Position
        plane.Visible = True
    End Sub

    Private Function targetedObj(pos As Vector3, maxDist As Double)
        Dim vec As Vector3 = pos
        Dim vecGround As Vector3
        Dim deadPed As Ped = Nothing
        Dim tmpDist As Double
        Dim tmpPosCompare As Vector3

        If (findTargetTime >= 200) Then DETarget.valid = False

        If (findTargetTime >= 200) OrElse Not Exists(DEPossibleTargetVeh) OrElse Not Exists(DEPossibleTargetPed) Then
            DEPossibleTargetVeh = World.GetVehicles(Game.CurrentCamera.Position + Game.CurrentCamera.Direction * 100, 200)
            DEPossibleTargetPed = World.GetPeds(Game.CurrentCamera.Position + Game.CurrentCamera.Direction * 100, 200)
        End If

        For Each v As Vehicle In DEPossibleTargetVeh
            If Exists(v) AndAlso (v <> Player.Character.CurrentVehicle) Then
                tmpDist = v.Position.DistanceTo(Game.CurrentCamera.Position)
                tmpPosCompare = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * tmpDist

                If v.Position.DistanceTo(tmpPosCompare) < 1.5 Then
                    DETarget.reset()
                    DETarget.v = v
                    DETarget.bVeh = True
                    DETarget.valid = True
                    Return True
                End If
            End If
        Next

        For Each p As Ped In DEPossibleTargetPed
            If Exists(p) AndAlso (p <> Player.Character) Then
                tmpDist = p.Position.DistanceTo(Game.CurrentCamera.Position)
                tmpPosCompare = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * tmpDist

                If p.Position.DistanceTo(tmpPosCompare) < 1.5 Then
                    If Not p.isAlive OrElse (p.Health <= 0) Then
                        deadPed = p
                    Else
                        DETarget.reset()
                        DETarget.p = p
                        DETarget.bPed = True
                        DETarget.valid = True
                        Return True
                    End If
                End If
            End If
        Next

        If findTargetTime >= 200 Then
            While vec.DistanceTo(Player.Character.Position) < maxDist
                vec += Game.CurrentCamera.Direction / 2

                If vec.DistanceTo(Player.Character.Position) < 3 Then Continue While

                vecGround = World.GetGroundPosition(vec, GroundType.Highest)

                If vec.DistanceTo(vecGround) <= 1.0 Then
                    DETarget.reset()
                    DETarget.vec = vec
                    DETarget.valid = True
                    Return True
                End If
            End While
        End If

        If Exists(deadPed) Then
            DETarget.reset()
            DETarget.p = deadPed
            DETarget.bPed = True
            DETarget.valid = True
            Return True
        End If

        Return False
    End Function

    Private Sub general_tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If loadDelay > 0 Then
            loadDelay -= Me.Interval

            If loadDelay <= 0 Then loadAux()
        End If

        timeScript += 10

        If timeScript > 3000 Then timeScript = 0

        If timeWaitResetDeathArrest > 0 Then timeWaitResetDeathArrest -= intervalFix()

        If bInAC130 Then
            If ((timeScript Mod 100) = 0) AndAlso ((Player.Character.Health <= 0) OrElse (Native.Function.Call(Of Boolean)("IS_PLAYER_BEING_ARRESTED"))) Then
                If Not bDeadEye Then toggleONOff(hkActivate1) Else toggleONOff(hkActivate2)

                timeWaitResetDeathArrest = 5000

                Exit Sub
            End If

            If bDeadEye Then
                If Game.isGameKeyPressed(GameKey.Aim) Then
                    Player.Character.Task.ClearAll()
                    Player.Character.Weapons.inSlot(WeaponSlot.Unarmed).Select()

                    DETargetUpdateVec()

                    If Player.Character.isAlive AndAlso (DEShoots <= 0) AndAlso Not Rocket.Metadata.launched Then _
                        targetedObj(Player.Character.GetBonePosition(Bone.Head), maxDistFindTargets)

                    If findTargetTime >= 200 Then
                        findTargetTime = 0
                    Else
                        findTargetTime += intervalFix()
                    End If

                    If DETarget.valid Then
                        drawTargetedHUD(DETarget)
                    End If
                End If

                If Not Game.isGameKeyPressed(GameKey.Aim) Then
                    If camDEAim.isActive Then camDEAim.Deactivate()
                Else
                    If Not camDEAim.isActive Then camDEAim.Activate()
                End If

                If camDEAim.isActive Then
                    If Not Game.Mouse.isButtonDown(System.Windows.Forms.MouseButtons.Middle) Then
                        'Dim zBack As Double = camDEDir.Z
                        'Dim mouseMovAux As System.Drawing.PointF = Game.Mouse.Movement

                        'mouseMovAux.X *= (camDEAimFOV / 50)
                        'mouseMovAux.Y *= (camDEAimFOV / 50)

                        'camDEDir = rotateVec(camDEDir, game.mouse.movement.x * -145)
                        'camDEDir = rotateVec(camDEDir, mouseMovAux.X * -145)
                        'camDEDir.z = zBack - game.mouse.movement.y * 3
                        'camDEDir.Z = zBack - mouseMovAux.Y * 3

                        camDEAim.Position = Player.Character.GetBonePosition(Bone.Head) + Player.Character.Direction / 2
                        camDEAim.FOV = camDEAimFOV
                        'camDEAim.Direction = camDEDir

                        If Exists(Game.DefaultCamera.Direction) Then _
                            camDEAim.Direction = Game.DefaultCamera.Direction

                        If Not Exists(Player.Character.CurrentVehicle) Then Player.Character.Heading = camDEAim.Heading
                    Else
                        camDEAimFOV += Game.Mouse.Movement.Y * 10

                        If camDEAimFOV < 10 Then
                            camDEAimFOV = 10
                        ElseIf camDEAimFOV > 50 Then
                            camDEAimFOV = 50
                        End If

                        camDEAim.FOV = camDEAimFOV
                    End If
                End If

                If DEShoots > 0 Then
                    DETargetUpdateVec()

                    If DETarget.valid Then
                        If (currWeapon = 1) AndAlso (timeShoot40mm <= 0) Then
                            DEShoots -= 1
                            fire40mm(True)
                        ElseIf (currWeapon = 2) AndAlso (timeShoot20mm <= 0) Then
                            DEShoots -= 1
                            Fire20mm(True)
                        End If
                    End If
                End If
            Else
                If camDEAim.isActive Then camDEAim.Deactivate()
            End If

            If camDelay > 0 Then
                camDelay -= 10

                If camDelay <= 0 Then bCancelLights = False
            End If

            If (camRocket.isActive) Then
                If (camRocket.Direction.Z < 0) Then
                    If Not bDeadEye Then plane.Visible = False
                End If

                If (camDelay <= 0) Then
                    If Not bDeadEye Then plane.Visible = False

                    camRocket.Deactivate()

                    If Not bDeadEye Then camAC130.Activate()
                End If
            End If

            If Exists(plane) Then
                fire105mm()

                fire40mm()

                Fire20mm()

                If Not bDeadEye Then
                    If (timeScript Mod 100 = 0) Then
                        'playerPosAux = getGroundPos(plane.position + camAC130.direction * 200, camAC130.direction)
                        playerPosAux = getGroundPos(camAC130.Position, camAC130.Direction, GroundType.Lowest) + Vector3.WorldUp * 10

                        If playerPosAux.DistanceTo(Player.Character.Position) > 25 Then
                            Player.Character.FreezePosition = True
                            Player.Character.FreezePosition = False
                            Player.Character.Position = playerPosAux
                            Player.Character.Heading = camAC130.Heading
                        End If
                    End If

                    Player.Character.Velocity = playerPosAux - Player.Character.Position

                    If NightVisionMode > 0 Then
                        NVTick()
                    End If

                    If Game.isKeyPressed(Keys.A) Then
                        planeHeading += 1.1
                    ElseIf Game.isKeyPressed(Keys.D) Then
                        planeHeading -= 1.1
                    End If

                    If planeHeading > 360 Then planeHeading = 0

                    plane.Heading = planeHeading

                    If currWeapon = 0 Then
                        plane.Position = plane.Position - plane.Direction * 0.4 * planeSpeedMultiplier
                    ElseIf currWeapon = 1 Then
                        plane.Position = plane.Position - plane.Direction * 0.3 * planeSpeedMultiplier
                    Else
                        plane.Position = plane.Position - plane.Direction * 0.2 * planeSpeedMultiplier
                    End If

                    If Not camAC130.isActive Then camAC130.Activate()

                    Dim mouseMovAux As System.Drawing.PointF = Game.Mouse.Movement

                    'mouseMovAux.x *= (camFOV / 50)
                    'mouseMovAux.y *= (camFOV / 50)

                    If currWeapon = 0 Then
                        'camAC130.position = plane.position + camDirOrig * 60 'camAC130.direction * 150
                        camAC130.Position = plane.Position + camAC130.Direction * 150
                    ElseIf currWeapon = 1 Then
                        'camAC130.position = plane.position + camDirOrig * 80 'camAC130.direction * 220
                        camAC130.Position = plane.Position + camAC130.Direction * 220
                        mouseMovAux.X /= 2
                        mouseMovAux.Y /= 2.5
                    ElseIf currWeapon = 2 Then
                        'camAC130.position = plane.position + camDirOrig * 110 'camAC130.direction * 250
                        'camAC130.position = plane.position + camAC130.direction * 250

                        camHeightAux = Math.Round(camDir.Z * 7)

                        If (camHeight <> camHeightAux) AndAlso (camHeight < camHeightAux) Then
                            camHeight += 1
                        ElseIf (camHeight <> camHeightAux) AndAlso (camHeight > camHeightAux) Then
                            camHeight -= 1
                        End If

                        camAC130.Position = plane.Position + camAC130.Direction * (250 + camHeight)

                        mouseMovAux.X /= 4
                        mouseMovAux.Y /= 5
                    End If

                    If Not Game.Mouse.isButtonDown(System.Windows.Forms.MouseButtons.Middle) Then
                        Dim camDirAux As Vector3 = rotateVec(camDir, mouseMovAux.X * -20)

                        camDir = camDirAux

                        If camDir.Z > -1 Then
                            camDir.Z -= mouseMovAux.Y / 2
                        Else
                            camDir.Z -= mouseMovAux.Y
                        End If

                        If (currWeapon = 2) AndAlso (camDir.Z < -3.5) Then
                            camDir.Z = -3.5
                        ElseIf camDir.Z < -4 Then
                            camDir.Z = -4
                        ElseIf camDir.Z > 0 Then
                            camDir.Z = 0
                        End If

                        camAC130.Direction = camDir
                    Else
                        camFOV += Game.Mouse.Movement.Y * 10

                        If camFOV < 1 Then
                            camFOV = 1
                        ElseIf camFOV > 100 Then
                            camFOV = 100
                        End If

                        camAC130.FOV = camFOV
                    End If

                    If shakeCam > 0 Then
                        camAC130.Position = camAC130.Position.Around(shakeCamAmount)

                        shakeCam -= 1
                    End If
                Else
                    updatePlaneMov()
                End If
            End If
        Else
            If bResetTimeCycle Then
                ClearNVLists()
                bResetTimeCycle = False
                Native.Function.Call("CLEAR_TIMECYCLE_MODIFIER")
            End If
        End If
    End Sub

    Private Sub drawTargetedHUD(ByVal target As targetFound)
        Dim tmpTargetPos As Vector3
        Dim tmpDistCoef As Double
        Dim tmpDiameterMulti As Double

        If Not target.bPed AndAlso Not target.bVeh Then
            tmpTargetPos = target.vec.ToGround
            tmpDistCoef = tmpTargetPos.DistanceTo(Game.CurrentCamera.Position) / 25
            Native.Function.Call("DRAW_CHECKPOINT_WITH_ALPHA", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, tmpDistCoef, 255, 0, 0, 75)
            Exit Sub
        End If

        camAimHUDObj.Position = Game.CurrentCamera.Position - Game.CurrentCamera.Direction * 20
        camAimHUDObj.Rotation = Game.CurrentCamera.Rotation

        If target.bPed Then
            tmpTargetPos = target.p.Position
            tmpDistCoef = target.p.Position.DistanceTo(Game.CurrentCamera.Position) / 100
            tmpDiameterMulti = 0.2
        ElseIf target.bVeh Then
            tmpTargetPos = target.v.Position
            tmpDistCoef = target.v.Position.DistanceTo(Game.CurrentCamera.Position) / 100
            tmpDiameterMulti = 0.5
        End If

        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeTop * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeTop * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeBottom * 6 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeBottom * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)

        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeTop * 4 * tmpDiameterMulti))
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeRight * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeRight * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)

        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeLeft * 6 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
        tmpTargetPos += (camAimHUDObj.Position - camAimHUDObj.GetOffsetPosition(Vector3.RelativeLeft * 2 * tmpDiameterMulti))
        Native.Function.Call("DRAW_CHECKPOINT", tmpTargetPos.X, tmpTargetPos.Y, tmpTargetPos.Z, 1 * tmpDistCoef, 255, 0, 0)
    End Sub


    Private Sub Fire20mm(Optional bDeadEyeShoot As Boolean = False)
        If timeShoot20mm <= 0 Then
            If (bDeadEyeShoot OrElse Game.isKeyPressed(hkShoot) OrElse (DEShoots > 0)) AndAlso (currWeapon = 2) Then
                timeShoot20mm = 20

                Dim iniPos, finPos As Vector3
                'dim effect as int32 = 0

                If Not bDeadEye Then
                    iniPos = Game.CurrentCamera.Position + Game.CurrentCamera.Direction * 10
                Else
                    iniPos = DETarget.vec + Vector3.WorldUp * 50
                End If

                'effect = Native.Function.Call(Of int32)("start_PTFX", "wpn_bullet_trace", iniPos.x, iniPos.y, iniPos.z, -10.0, -45.0, 0, 3.0)
                'Native.Function.Call("trigger_PTFX", "wpn_bullet_trace", iniPos.x, iniPos.y, iniPos.z, -10.0, -45.0, 0, 3.0)

                If Not bDeadEye Then
                    bDraw20mmTrace = True

                    PlaySound(".\scripts\AC130Files\20mm.wav")

                    iniPos = Game.CurrentCamera.Position
                    finPos = Game.CurrentCamera.Position.Around(2) + Game.CurrentCamera.Direction * 300
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                    finPos = Game.CurrentCamera.Position.Around(1) + Game.CurrentCamera.Direction * 300
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                    finPos = Game.CurrentCamera.Position.Around(1) + Game.CurrentCamera.Direction * 300
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                Else
                    PlaySound(".\scripts\AC130Files\20mm2.wav")

                    If DETarget.bPed Then finPos = DETarget.vec.ToGround.Around(0.5) Else finPos = DETarget.vec.ToGround.Around(1.5)
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                    If DETarget.bPed Then finPos = DETarget.vec.ToGround.Around(0.5) Else finPos = DETarget.vec.ToGround.Around(1.5)
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                    If DETarget.bPed Then finPos = DETarget.vec.ToGround.Around(0.5) Else finPos = DETarget.vec.ToGround.Around(1.5)
                    Native.Function.Call("FIRE_SINGLE_BULLET", iniPos.X, iniPos.Y, iniPos.Z, finPos.X, finPos.Y, finPos.Z, 1000)
                End If

                'native.function.call("stop_ptfx", effect)

                If dot20mmTimeScarePeds <= 0 Then
                    dot20mmTimeScarePeds = 50

                    Dim vecAux As Vector3

                    If Not bDeadEye Then
                        vecAux = getGroundPos(iniPos, Game.CurrentCamera.Direction)
                    Else
                        vecAux = DETarget.vec
                    End If

                    For Each p As Ped In World.GetPeds(vecAux, 7.0)
                        If Exists(p) AndAlso (p <> Player.Character) AndAlso Not p.Metadata.flee Then
                            p.Task.FleeFromChar(Player.Character, False)
                            p.Metadata.flee = True
                        End If
                    Next
                Else
                    dot20mmTimeScarePeds -= intervalFix()
                End If

                Dim doorTmp As Int16 = 0

                For Each v As Vehicle In World.GetVehicles(finPos, 2)
                    If Exists(v) Then
                        v.ApplyForce(Vector3.WorldDown / 4)

                        doorTmp = random(0, 5)

                        Native.Function.Call("break_car_door", v, doorTmp, False)
                    End If
                Next

                shakeCam = 1
                shakeCamAmount = 0.1
            End If
        Else
            timeShoot20mm -= intervalFix()
        End If
    End Sub

    Private Sub fire40mm(Optional bShoot As Boolean = False)
        If timeShoot40mm > 0 Then timeShoot40mm -= intervalFix()

        If (currWeapon = 1) AndAlso ((Game.isKeyPressed(hkShoot) AndAlso camAC130.isActive) OrElse bShoot) Then
            If timeShoot40mm <= 0 Then
                timeShoot40mm = 50

                If Exists(dot40mmList.Item(dot40mmBullet).bullet) Then
                    If Not dot40mmList.Item(dot40mmBullet).launched Then
                        dot40mmList.Item(dot40mmBullet).launched = True
                        dot40mmList.Item(dot40mmBullet).bullet.Detach()

                        If Not bDeadEye Then
                            dot40mmList.Item(dot40mmBullet).bullet.Position = camAC130.Position
                            dot40mmList.Item(dot40mmBullet).dir = camAC130.Direction * 100
                        Else
                            dot40mmList.Item(dot40mmBullet).bullet.Position = DETarget.vec + Vector3.WorldUp * 50
                        End If

                        'dot40mmList.item(dot40mmBullet).bullet.visible = true

                        'If dot40mmList.Item(dot40mmBullet).ptfx = 0 Then _
                        '    dot40mmList.Item(dot40mmBullet).ptfx = Native.Function.Call(Of Int32)("START_PTFX_ON_OBJ", "ambient_cig_smoke", _
                        '        dot40mmList.Item(dot40mmBullet).bullet, 0, 0, 0, 0, 0, 0, 5.0)

                        Native.Function.Call("SET_OBJECT_RECORDS_COLLISIONS", dot40mmList.Item(dot40mmBullet).bullet, 1)

                        If Not bDeadEye Then
                            PlaySound(".\scripts\AC130Files\40mm.wav")
                        Else
                            PlaySound(".\scripts\AC130Files\40mm2.wav")
                        End If

                        shakeCam = 2
                        shakeCamAmount = 0.3
                    End If
                End If

                dot40mmBullet += 1

                If dot40mmBullet > dot40mmList.Count - 1 Then dot40mmBullet = 0
            End If
        End If

        For Each b As dot40mm In dot40mmList
            If Exists(b.bullet) Then
                If b.launched Then
                    If ((b.bullet.Position.DistanceTo(plane.Position) > 20) AndAlso Native.Function.Call(Of Boolean)("HAS_OBJECT_COLLIDED_WITH_ANYTHING", b.bullet)) _
                       OrElse (b.timeOut >= 1000) Then
                        b.timeOut = 0
                        b.launched = False

                        'Native.Function.Call("stop_ptfx", b.ptfx)

                        If Not bDeadEye Then
                            Native.Function.Call("trigger_PTFX", "exp_grenade", b.bullet.Position.X, b.bullet.Position.Y, b.bullet.Position.Z, 0, 0, 0, 0.5)
                        Else
                            Native.Function.Call("trigger_PTFX", "exp_grenade", b.bullet.Position.X, b.bullet.Position.Y, b.bullet.Position.Z, 0, 0, 0, 0.2)
                        End If

                        Dim vL As Vehicle()
                        vL = World.GetVehicles(b.bullet.Position, 6.0)

                        For Each v As Vehicle In vL
                            If Exists(v) Then Native.Function.Call("SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE", v, 0)
                        Next

                        If bDeadEye Then
                            If Not DETarget.bPed Then
                                World.AddExplosion(b.bullet.Position + Vector3.WorldUp / 2, ExplosionType.Rocket, 0.5, True, True, 0.05)
                            Else
                                World.AddExplosion(b.bullet.Position + Vector3.WorldUp, ExplosionType.Rocket, 0.5, True, True, 0.05)
                            End If
                        Else
                            World.AddExplosion(b.bullet.Position + Vector3.WorldUp / 2, ExplosionType.Rocket, 0.5, False, True, 0.05)
                        End If

                        Native.Function.Call("SET_OBJECT_RECORDS_COLLISIONS", b.bullet, 0)

                        Native.Function.Call("ATTACH_OBJECT_TO_OBJECT", b.bullet, plane, False, 0, 0, 0, 0, 0, 0)

                        b.bullet.Visible = False

                        For Each v As Vehicle In vL
                            If Exists(v) Then v.PetrolTankHealth = 1000
                        Next
                    Else
                        If Not bDeadEye Then
                            b.bullet.ApplyForce(b.dir)
                        Else
                            b.bullet.ApplyForce((DETarget.vec.Around(2) - b.bullet.Position))
                        End If

                        Native.Function.Call("draw_corona", b.bullet.Position.X, b.bullet.Position.Y, b.bullet.Position.Z, 20.0, 0, 0, 255, 255, 200)

                        b.timeOut += intervalFix()
                    End If
                End If
            Else
                Dim tmp40mm As dot40mm

                tmp40mm = New dot40mm(Player.Character.Position + Vector3.WorldUp * 2, plane)

                dot40mmList.Add(tmp40mm)
            End If
        Next
    End Sub

    Private Sub fire105mm(Optional bSet As Boolean = False)
        If bSet Then
            If Not bDeadEye Then
                shakeCam = 5
                shakeCamAmount = 1.5
            End If

            RocketExpTimeout = 2000
            RocketDelay = 150
            Rocket.Metadata.launched = True

            If camMode = 1 Then
                camRocket.Direction = camAC130.Direction
                camRocket.Position = camAC130.Position '- camAC130.direction * 2
                camRocket.LookAt(camRocket.Position + camRocket.Direction * 300)
            ElseIf camMode = 2 Then
                'camRocket.position = (world.GetNextPositionOnStreet(getGroundPos(camAC130.position, camAC130.direction)) + vector3.worldup * 35)					
                camRocket.Position = (getGroundPos(camAC130.Position, camAC130.Direction) + Vector3.WorldUp * 35).Around(5)
                camDelay = 1500
            End If

            If rocketEffect <> 0 Then Native.Function.Call("stop_ptfx", rocketEffect)

            rocketEffect = Native.Function.Call(Of Int32)("START_PTFX_ON_OBJ", "weap_rocket_player", Rocket, 0, 0, 0, 0, 0, 0, 0.4)

            Native.Function.Call("SET_OBJECT_RECORDS_COLLISIONS", Rocket, 1)

            'rocketRotation = game.currentcamera.direction				
            rocketRotation = camAC130.Direction

            If (camMode = 1) OrElse (camMode = 2) Then
                timeScript = 490
                bCancelLights = True
            End If

            If Not bDeadEye Then
                PlaySound(".\scripts\AC130Files\105mm.wav")
            Else
                PlaySound(".\scripts\AC130Files\105mm2.wav")
            End If

            'rocket.visible = true

            Exit Sub
        End If

        If Rocket.Metadata.launched Then
            If RocketDelay <= 0 Then
                If camMode = 1 Then
                    camRocket.Position = Rocket.Position

                    If Not camRocket.isActive Then camRocket.Activate()
                ElseIf camMode = 2 Then
                    camRocket.LookAt(Rocket.Position)

                    If Not camRocket.isActive Then
                        camRocket.Activate()
                        plane.Visible = True
                    End If
                End If

                RocketExpTimeout -= 10

                If ((Rocket.Position.DistanceTo(plane.Position) > 20) AndAlso Native.Function.Call(Of Boolean)("HAS_OBJECT_COLLIDED_WITH_ANYTHING", Rocket)) OrElse (RocketExpTimeout <= 0) Then
                    Native.Function.Call("SET_OBJECT_RECORDS_COLLISIONS", Rocket, 0)

                    Dim rocketPos As Vector3 = Rocket.Position
                    Dim effectPos As Vector3 = rocketPos.Around(10)
                    Native.Function.Call("trigger_PTFX", "exp_ship_destroy", rocketPos.X, rocketPos.Y, rocketPos.Z, 0, 0, 0, 1.0)
                    Native.Function.Call("trigger_PTFX", "exp_ship_destroy", effectPos.X, effectPos.Y, rocketPos.Z, 0, 0, 0, 1.0)
                    effectPos = rocketPos.Around(10)
                    Native.Function.Call("trigger_PTFX", "exp_ship_destroy", effectPos.X, effectPos.Y, rocketPos.Z, 0, 0, 0, 1.0)
                    World.AddExplosion(rocketPos, ExplosionType.Rocket, 100.0, True, True, 1.0)
                    World.AddExplosion(rocketPos.Around(10), ExplosionType.Rocket, 100.0, True, True, 1.0)
                    World.AddExplosion(rocketPos.Around(10), ExplosionType.Rocket, 100.0, True, True, 1.0)

                    For Each v As Vehicle In World.GetVehicles(rocketPos, 30.0)
                        If Exists(v) AndAlso (Math.Abs(v.Position.Z - rocketPos.Z) < 3) Then
                            If Not v.Model.isTrain Then
                                Native.Function.Call("detach_car", v)
                                v.FreezePosition = False
                                v.ApplyForce(((v.Position - rocketPos) + Vector3.WorldUp * 3) / (v.Position.DistanceTo(rocketPos) / 6), Vector3.WorldUp * 4)

                                If v.Position.DistanceTo(rocketPos) <= 20 Then v.PetrolTankHealth = -1
                            Else
                                trainItem = New trains(v)
                                trainList.Add(trainItem)
                                ClearNVLists()
                                v.Delete()
                            End If
                        End If
                    Next
                    For Each p As Ped In World.GetPeds(rocketPos, 30.0)
                        If Exists(p) Then
                            If bDeadEye AndAlso (p.Position.DistanceTo(rocketPos) <= 20) Then p.Health = Math.Round(p.Health / 2)

                            p.PreventRagdoll = False
                            p.Euphoria.BodyBalance.Start(5000)
                            p.ApplyForce(((p.Position - rocketPos) + Vector3.WorldUp * 2) / (p.Position.DistanceTo(rocketPos) / 10))
                        End If
                    Next

                    Dim fakeTrain As GTA.Object = Nothing

                    For Each t As trains In trainList
                        If t.bCreate Then
                            fakeTrain = World.CreateObject(t.m, t.pos)

                            If Exists(fakeTrain) Then
                                t.train = fakeTrain
                                t.train.Rotation = t.rot
                            End If
                        End If
                    Next
                    For Each t As trains In trainList
                        If Exists(t.train) Then
                            If t.bCreate Then
                                World.AddExplosion(t.train.Position, ExplosionType.Rocket, 1.0)
                                'wait(100)
                                t.train.ApplyForce(((t.train.Position - rocketPos) + Vector3.WorldUp * 6) / (t.train.Position.DistanceTo(rocketPos) / 6), Vector3.WorldUp * 4)
                            ElseIf t.train.Position.DistanceTo(rocketPos) < 30 Then
                                t.train.ApplyForce(((t.train.Position - rocketPos) + Vector3.WorldUp * 6) / (t.train.Position.DistanceTo(rocketPos) / 6), Vector3.WorldUp * 4)
                            End If
                        End If

                        t.bCreate = False
                    Next

                    Native.Function.Call("ATTACH_OBJECT_TO_OBJECT", Rocket, plane, False, 0, -10.0, 0, 0, 0, 0)

                    Rocket.Metadata.launched = False

                    If camMode = 1 Then
                        camRocket.Deactivate()

                        If Not bDeadEye Then camAC130.Activate()
                    End If

                    If camMode <> 2 Then bCancelLights = False

                    Rocket.Visible = False
                Else
                    'Rocket.velocity = rocketRotation * 250
                    If Not bDeadEye Then
                        Rocket.ApplyForce(rocketRotation * 100)
                    Else
                        Rocket.ApplyForce((DETarget.vec - Rocket.Position))
                    End If

                    Native.Function.Call("draw_corona", Rocket.Position.X, Rocket.Position.Y, Rocket.Position.Z, 150.0, 0, 0, 255, 255, 200)
                End If
            Else
                If RocketDelay > 0 Then RocketDelay -= 10

                If RocketDelay <= 0 Then
                    Rocket.Detach()
                    Rocket.Position = camAC130.Position - camAC130.Direction * 3
                    Rocket.ApplyForce(rocketRotation)
                End If
            End If
        End If
    End Sub

    Private Function getGroundPos(pos As Vector3, dir As Vector3, Optional pGroundType As GroundType = GroundType.Highest)
        Dim vecRes As Vector3 = World.GetGroundPosition(pos, pGroundType)
        Dim dist As Double
        Dim minDist As Double = 100000

        While (vecRes.DistanceTo(pos) > 1)
            pos += dir / 2

            vecRes = World.GetGroundPosition(pos, pGroundType)

            dist = vecRes.DistanceTo(pos)

            If dist < minDist Then
                minDist = dist
            Else
                Exit While
            End If
        End While

        Return vecRes
    End Function

    Private Sub drawSpriteAux(ByVal e As GTA.GraphicsEventArgs, ByVal tex As Texture, ByVal x As Double, ByVal y As Double, ByVal w As Double, ByVal h As Double, _
       ByVal rot As Double, ByVal col As Color, Optional ByVal square As Boolean = False)
        If square Then
            e.Graphics.DrawSprite(tex, x * width_coef, y * height_coef, w * width_coef, h * height_coef, rot, col)
        Else
            e.Graphics.DrawSprite(tex, x * width_coef, y * height_coef, w * width_coef, w * height_coef, rot, col)
        End If
    End Sub

    Private Sub drawRectangleAux(ByVal e As GTA.GraphicsEventArgs, ByVal x As Double, ByVal y As Double, ByVal w As Double, ByVal h As Double, ByVal col As Color)
        e.Graphics.DrawRectangle(x * width_coef, y * height_coef, w * width_coef, h * height_coef, col)
    End Sub

    Private Sub GraphicsEventHandler(ByVal sender As Object, ByVal e As GTA.GraphicsEventArgs) Handles MyBase.PerFrameDrawing
        Try
            bErroDraw = False

            If bInAC130 Then
                If Not bDeadEye Then
                    If Not bDisableTextures Then
                        If currWeapon = 0 Then
                            If (camMode = 0) Or ((camMode <> 0) And Not Rocket.Metadata.launched And (camDelay <= 0)) Then _
                                drawSpriteAux(e, texCr105, 840, 525, 874, 576, 0, Color.White, True)
                        ElseIf currWeapon = 1 Then
                            drawSpriteAux(e, texCr40, 840, 525, 874, 576, 0, Color.White, True)
                        Else
                            drawSpriteAux(e, texCr20, 840, 525, 874, 576, 0, Color.White, True)
                        End If
                    End If

                    If Not bDisableTextures AndAlso bDraw20mmTrace Then
                        drawSpriteAux(e, text20mmTrace, 840, 525, 1680, 1050, 0, Color.White)

                        bDraw20mmTrace = False
                    End If

                    If bCancelLights Then Exit Sub

                    drawRectangleAux(e, 840, 525, 5, 5, Color.FromArgb(150, 255, 0, 0))

                    If NightVisionMode = 1 Then
                        drawRectangleAux(e, 840, 525, 1680, 1050, Color.FromArgb(80, 0, 255, 0))
                    ElseIf NightVisionMode = 2 Then
                        drawRectangleAux(e, 840, 525, 1680, 1050, Color.FromArgb(100, 50, 50, 50))
                    End If

                   ' If Not bDisableTextures AndAlso bNoiseFX Then
                   '     If noiseEffectCounter < 2 Then
                   '         drawSpriteAux(e, textN1, myWidth / 2, myHeight / 2, myWidth, myHeight, 0, Color.White)
                   '     ElseIf noiseEffectCounter < 4 Then
                   '         drawSpriteAux(e, textN2, myWidth / 2, myHeight / 2, myWidth, myHeight, 0, Color.White)
                   '     ElseIf noiseEffectCounter < 6 Then
                   '         drawSpriteAux(e, textN3, myWidth / 2, myHeight / 2, myWidth, myHeight, 0, Color.White)
                   '     ElseIf noiseEffectCounter < 8 Then
                   '         drawSpriteAux(e, textN4, myWidth / 2, myHeight / 2, myWidth, myHeight, 0, Color.White)
                   '     Else
                   '         noiseEffectCounter = 0
                   '         drawSpriteAux(e, textN1, myWidth / 2, myHeight / 2, myWidth, myHeight, 0, Color.White)
                   '     End If
                   '
                   '    noiseEffectCounter += 1
                   ' End If
                Else
                    If Game.isGameKeyPressed(GameKey.Aim) Then
                        If Not bDisableTextures AndAlso Player.Character.isAlive Then _
                            drawSpriteAux(e, textDEAim, 840, 525, 1680, 1050, 0, Color.White, True)
                    End If
                End If

                If Not bDeadEye OrElse (bDeadEye AndAlso Game.isGameKeyPressed(GameKey.Aim)) Then
                    drawSpriteAux(e, tex105, 70, 680, 113, 49, 0, Color.DarkGray, True)
                    drawSpriteAux(e, tex40, 70, 730, 113, 49, 0, Color.DarkGray, True)
                    drawSpriteAux(e, tex20, 70, 780, 113, 49, 0, Color.DarkGray, True)

                    If currWeapon = 0 Then
                        If (camMode = 0) Or ((camMode <> 0) And Not Rocket.Metadata.launched And (camDelay <= 0)) Then _
                            drawSpriteAux(e, tex105, 70, 680, 113, 49, 0, Color.White, True)
                    End If
                    If currWeapon = 1 Then drawSpriteAux(e, tex40, 70, 730, 113, 49, 0, Color.White, True)
                    If currWeapon = 2 Then drawSpriteAux(e, tex20, 70, 780, 113, 49, 0, Color.White, True)
                End If
            End If
        Catch
            bErroDraw = True
        End Try

        If bInAC130 AndAlso (bDisableTextures OrElse bErroDraw OrElse Not bCrosshair) Then
            If (Not bDeadEye OrElse (bDeadEye AndAlso Game.isKeyPressed(Keys.RButton))) Then _
                drawRectangleAux(e, myWidth / 2, myHeight / 2, 5, 5, Color.FromArgb(150, 255, 0, 0))

            If (Not bDeadEye AndAlso (currWeapon = 0) OrElse (bDeadEye AndAlso Game.isKeyPressed(Keys.RButton))) Then
                drawRectangleAux(e, myWidth / 2, myHeight / 2.5, 300, 2, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2, myHeight / 1.67, 300, 2, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 1.699, myHeight / 2, 2, 200, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2.44, myHeight / 2, 2, 200, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2.64, myHeight / 2, 100, 2, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 1.615, myHeight / 2, 100, 2, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2, myHeight / 2.85, 2, 100, Color.FromArgb(100, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2, myHeight / 1.541, 2, 100, Color.FromArgb(100, 255, 255, 255))
            ElseIf Not bDeadEye AndAlso (currWeapon = 1) Then
                drawRectangleAux(e, myWidth / 2, myHeight / 2, 400, 2, Color.FromArgb(75, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2, myHeight / 2, 2, 250, Color.FromArgb(75, 255, 255, 255))
            ElseIf Not bDeadEye AndAlso (currWeapon = 2) Then
                drawRectangleAux(e, myWidth / 2.35, myHeight / 2, 200, 2, Color.FromArgb(75, 255, 255, 255))
                drawRectangleAux(e, myWidth / 1.74, myHeight / 2, 200, 2, Color.FromArgb(75, 255, 255, 255))
                drawRectangleAux(e, myWidth / 2, myHeight / 1.73, 2, 125, Color.FromArgb(75, 255, 255, 255))
            End If

            If (currWeapon = 0) Then
                e.Graphics.DrawText(hkSwTo105mm.ToString & " - 105mm", 15, myHeight / 1.4)
                e.Graphics.DrawText(hkSwTo40mm.ToString & " - 40mm", 15, myHeight / 1.45, System.Drawing.Color.Gray)
                e.Graphics.DrawText(hkSwTo20mm.ToString & " - 20mm", 15, myHeight / 1.5, System.Drawing.Color.Gray)
            ElseIf (currWeapon = 1) Then
                e.Graphics.DrawText(hkSwTo105mm.ToString & " - 105mm", 15, myHeight / 1.4, System.Drawing.Color.Gray)
                e.Graphics.DrawText(hkSwTo40mm.ToString & " - 40mm", 15, myHeight / 1.45)
                e.Graphics.DrawText(hkSwTo20mm.ToString & " - 20mm", 15, myHeight / 1.5, System.Drawing.Color.Gray)
            ElseIf (currWeapon = 2) Then
                e.Graphics.DrawText(hkSwTo105mm.ToString & " - 105mm", 15, myHeight / 1.4, System.Drawing.Color.Gray)
                e.Graphics.DrawText(hkSwTo40mm.ToString & " - 40mm", 15, myHeight / 1.45, System.Drawing.Color.Gray)
                e.Graphics.DrawText(hkSwTo20mm.ToString & " - 20mm", 15, myHeight / 1.5)
            End If

            If bDeadEye AndAlso DETarget.valid Then _
                e.Graphics.DrawText("Locked", 15, myHeight / 1.3)
        End If
    End Sub

    Shared Function intervalFix()
        Return (10 * (25 / Game.FPS))
    End Function

    Private Sub PlaySound(sFile As String)
        Try
            Dim Sound As New System.Media.SoundPlayer()

            Sound.SoundLocation = sFile
            Sound.Load()
            Sound.Play()
        Catch
        End Try
    End Sub

    Function rotateVec(vec As Vector3, angle As Double)
        angle = angle * (3.1415 / 180)

        Dim s As Double = System.Math.Sin(angle)
        Dim c As Double = System.Math.Cos(angle)

        vec.X = vec.X * c - vec.Y * s
        vec.Y = vec.X * s + vec.Y * c

        Return vec
    End Function

    Private Function random(ByVal min As Int32, ByVal max As Int32)
        Dim rnd As Random = New Random(System.DateTime.Now.Millisecond)
        random = rnd.Next(min, max)
    End Function
End Class